Attribute VB_Name = "IniModule"
Option Explicit
'VB INI ` APIɂinit@C̓ǂݏ[VisualBasic wZ > VB6 u ]
'http://homepage1.nifty.com/rucio/main/tyukyu/tyukyu8.htm

Private Declare Function GetPrivateProfileString Lib "kernel32" _
    Alias "GetPrivateProfileStringA" ( _
        ByVal lpApplicationName As String, _
        ByVal lpKeyName As Any, _
        ByVal lpDefault As String, _
        ByVal lpReturnedString As String, _
        ByVal nSize As Long, _
        ByVal lpFileName As String _
    ) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" _
    Alias "WritePrivateProfileStringA" ( _
        ByVal lpApplicationName As String, _
        ByVal lpKeyName As Any, _
        ByVal lpString As Any, _
        ByVal lpFileName As String _
    ) As Long

Public Function GetINIValue(iniName As String, section As String, key As String, Optional defaultValue As String = "") As String
    
    Dim value As String * 255
    
    Call GetPrivateProfileString(section, key, defaultValue, value, Len(value), iniName)
    GetINIValue = Left$(value, InStr(1, value, vbNullChar) - 1)
    
End Function

Public Function GetINIBoolean(iniName As String, section As String, key As String, Optional defaultBoolean As String = False) As Boolean

    Dim tmp As String
    tmp = GetINIValue(iniName, section, key)
    
    If (UCase(tmp) = "TRUE") Then
        GetINIBoolean = True
    ElseIf (UCase(tmp) = "FALSE") Then
        GetINIBoolean = False
    Else
        GetINIBoolean = defaultBoolean
    End If
    
End Function

Public Function SetINIValue(iniName As String, section As String, key As String, value As String) As Boolean

    Dim Ret As Long
    
    Ret = WritePrivateProfileString(section, key, value, iniName)
    SetINIValue = CBool(Ret)

End Function

Public Function SetINIBoolean(iniName As String, section As String, key As String, bool As Boolean) As Boolean

    Dim value As String
    value = IIf(bool, "TRUE", "FALSE")
    
    SetINIBoolean = SetINIValue(iniName, section, key, value)

End Function

Public Function DeleteINIValue(iniName As String, section As String, key As String) As Boolean

    Dim Ret As Long
    
    Ret = WritePrivateProfileString(section, key, ByVal 0&, iniName)
    DeleteINIValue = CBool(Ret)

End Function

