Attribute VB_Name = "PropertyModule"
Option Explicit

'INIt@C
Const INI_FILE_NAME = "SwitchApp.ini"

'EBhE \
Public Type appInfo
    windowName As String                'EBhE
    HitCondition As HitConditionEnum    'v
    sendKeyIndex() As Integer           'ML[
End Type

'eݒ
Public appInfo(2) As appInfo        'EBhE
Public hotKeyNumber As Long         '؂ւL[
Public NextSwitch As NextSwitchEnum 'ɐ؂ւAv

'NextSwitch萔
Public Enum NextSwitchEnum
    DoNothing = 0   'Ȃ
    DoReturn = 1    '̃Avɖ߂
    SwitchApp = 2   'ʂ̃Avɐ؂ւ
End Enum

'v萔 (ݒ̃Xgԍƈv悤ɔԍ蓖)
Public Enum HitConditionEnum
    Part = 0        'v
    Prefix = 1      'Ov
    Suffix = 2      'v
    Full = 3        'Sv
    RegExp = 4      'K\
End Enum

'RtBO[hiÑR}hCŔfj
Public configMode As Boolean

Public Sub ReadIni()

    Dim iniPath As String
    iniPath = App.Path & "\" & INI_FILE_NAME
    
    'KvɉāAINIt@C
    If Not (FileExists(iniPath)) Then
        InitINI (iniPath)
    End If
    
    Dim sendKey As String
    Dim sendKeyCode As String
    Dim spt() As String
    Dim i As Byte
    Dim j As Integer
    Dim k As Integer
    
    For i = 0 To 1
        'EBhE
        appInfo(i).windowName = GetINIValue(iniPath, "Window" & i, "WindowName")
        
        'v (o[WAbv͍ڂȂ̂ŁAɏ݂Ă)
        Dim condition As Integer
        condition = CInt(GetINIValue(iniPath, "Window" & i, "HitCondition", CInt(HitConditionEnum.Part)))
        Call SetINIValue(iniPath, "Window" & i, "HitCondition", CStr(condition))
        appInfo(i).HitCondition = condition
        
        'ML[
        sendKey = GetINIValue(iniPath, "Window" & i, "SendKey")
        spt() = Split(sendKey, ",")
        
        ReDim appInfo(i).sendKeyIndex(UBound(spt))
        For j = 0 To UBound(spt)
            sendKeyCode = CInt(spt(j))
            For k = 0 To UBound(keyconfig)
                If (sendKeyCode = keyconfig(k).code) Then
                    appInfo(i).sendKeyIndex(j) = k
                    Exit For
                End If
            Next
        Next
    Next
    
    hotKeyNumber = CInt(GetINIValue(iniPath, "Settings", "HotKey"))
    
    'o[W1.1.0̒ǉ
    If (GetINIValue(iniPath, "Settings", "NextSwitch") <> "") Then
        NextSwitch = CInt(GetINIValue(iniPath, "Settings", "NextSwitch"))
    End If
    
    'o[WAbv
    If (GetINIValue(iniPath, "Settings", "FirstOnly") <> "") Then
        NextSwitch = VersionUpFirstOnlyFlag(GetINIBoolean(iniPath, "Settings", "FirstOnly"))
        Call DeleteINIValue(iniPath, "Settings", "FirstOnly")
        Call SetINIValue(iniPath, "Settings", "NextSwitch", CStr(NextSwitch))
    End If
    
    'o[W񏑂
    Call SetINIValue(iniPath, "Settings", "Version", App.Major & "." & App.Minor & App.Revision)
End Sub

Public Sub WriteINI()
    
    Dim iniPath As String
    iniPath = App.Path & "\" & INI_FILE_NAME
    
    Dim i As Integer
    Dim j As Integer
    For i = 0 To 1
        Dim sendKey As String
        sendKey = keyconfig(appInfo(i).sendKeyIndex(0)).code
        For j = 1 To UBound(appInfo(i).sendKeyIndex)
            sendKey = sendKey & "," & keyconfig(appInfo(i).sendKeyIndex(j)).code
        Next
    
        Call SetINIValue(iniPath, "Window" & i, "WindowName", appInfo(i).windowName)
        Call SetINIValue(iniPath, "Window" & i, "HitCondition", CStr(appInfo(i).HitCondition))
        Call SetINIValue(iniPath, "Window" & i, "SendKey", sendKey)
    Next
    
    Call SetINIValue(iniPath, "Settings", "HotKey", CStr(hotKeyNumber))
    Call SetINIValue(iniPath, "Settings", "NextSwitch", CStr(NextSwitch))
    
End Sub

't@C̑݃`FbN
Private Function FileExists(iniPath) As Boolean
    Dim Ret As Boolean
    
    ' FileSystemObject (FSO) ̐VCX^X𐶐
    Dim cFso As FileSystemObject
    Set cFso = New FileSystemObject

    ' t@C݂Ă邩ǂmF
    Ret = cFso.FileExists(iniPath)

    ' svɂȂ_ŎQƂ
    Set cFso = Nothing
    
    FileExists = Ret
End Function

'INIt@C̏f[^
Private Sub InitINI(iniPath As String)
    Dim fileNo As Integer
    fileNo = FreeFile
    
    Open iniPath For Output As #fileNo
  
    Print #fileNo, ";SwitchApp"
    Print #fileNo, ""
    Print #fileNo, "[Window0]"
    Print #fileNo, "WindowName=Mozilla Firefox"
    Print #fileNo, "HitCondition=" & HitConditionEnum.Part
    Print #fileNo, "SendKey=144,0,0"
    Print #fileNo, ""
    Print #fileNo, "[Window1]"
    Print #fileNo, "WindowName=Eclipse"
    Print #fileNo, "HitCondition=" & HitConditionEnum.Part
    Print #fileNo, "SendKey=0,0,0"
    Print #fileNo, ""
    Print #fileNo, "[Settings]"
    Print #fileNo, ";؂ւɎgL[i1AltA2CtrlA4Shiftj"
    Print #fileNo, "HotKey=2"
    Print #fileNo, "NextSwitch=" & NextSwitchEnum.DoReturn
    Print #fileNo, "Version=" & App.Major & "." & App.Minor & App.Revision

    Close #fileNo
End Sub

'uɈԂ̃Avɐ؂ւvuɐ؂ւAvvɕύXɂȂƂւ̏u
Private Function VersionUpFirstOnlyFlag(firstOnlyFlag As Boolean) As Integer
    If (firstOnlyFlag) Then
        VersionUpFirstOnlyFlag = NextSwitchEnum.DoNothing
    Else
        VersionUpFirstOnlyFlag = NextSwitchEnum.SwitchApp
    End If
End Function
