Attribute VB_Name = "SwitchAppModule"
Option Explicit

Private Type POINTAPI
    X As Long                        'XW
    Y As Long                        'YW
End Type

Private Type RECT
    Left As Long            '`̍XW
    Top As Long             'AYW
    Right As Long           '`̉EXW
    Bottom As Long          'AYW
End Type

Private Declare Function IsIconic Lib "user32.dll" (ByVal hWnd As Long) As Long

Private Declare Function ShowWindow Lib "user32.dll" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Private Const SW_SHOWMAXIMIZED = 3
Private Const SW_SHOWNOACTIVATE = 4

Private Declare Function GetWindowPlacement Lib "user32.dll" (ByVal hWnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Private Const WPF_SETMINIPOSITION = &H1         'ACRƂAptMinPositionňʒuw
Private Const WPF_RESTORETOMAXIMIZED = &H2      '̏Ԃɖ߂Ƃɍő剻
Private Type WINDOWPLACEMENT
       length As Long             '\̂̃TCY(oCg)
       flags As Long              'ACRꂽEBhËʒu
                                  'A@w肷萔̑gݍ킹
       showCmd As Long            '\Ԃw肷萔
       ptMinPosition As POINTAPI  'ACRԂ̕\ʒu
       ptMaxPosition As POINTAPI  'ő剻Ԃ̕\ʒu
       rcNormalPosition As RECT   'ʏԂ̕\ʒu
End Type

Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function timeGetTime Lib "winmm.dll" () As Long

'AvP[V؂ւ
Public Sub SwitchActiveApp()
    'ÕEBhEnh
    Static oldHandle As Long

    Dim handle(2) As Long
    handle(0) = GetWindowHandle(appInfo(0).windowName, CInt(appInfo(0).HitCondition))
    
    Dim Index As Integer
    
    If (NextSwitch = DoNothing) Then
        'ɈԂ̃Avɐ؂ւ
        Index = 0
    ElseIf (NextSwitch = DoReturn) Then
        handle(1) = oldHandle
        Index = IIf(GetForegroundWindow() = handle(0), 1, 0)
        
        If (oldHandle = 0) Then
            Index = 0
        End If
    ElseIf (NextSwitch = NextSwitchEnum.SwitchApp) Then
        handle(1) = GetWindowHandle(appInfo(1).windowName, CInt(appInfo(1).HitCondition))
        Index = IIf(GetForegroundWindow() = handle(0), 1, 0)
    End If
    
    'EBhE؂ւƃL[M
    If (handle(Index) <> 0) Then
        'ŏĂ邩
        If (IsIconic(handle(Index)) <> 0) Then
            'ŏÕEBhEԂ擾
            Dim windowPlacementInfo As WINDOWPLACEMENT
            Call GetWindowPlacement(handle(Index), windowPlacementInfo)
            
            If (windowPlacementInfo.flags = WPF_RESTORETOMAXIMIZED) Then
                'ő剻
                Call ShowWindow(handle(Index), SW_SHOWMAXIMIZED)
            Else
                '̃TCYɖ߂
                Call ShowWindow(handle(Index), SW_SHOWNOACTIVATE)
            End If
        End If
        
        'tHAOEhiANeBuj
        oldHandle = GetForegroundWindow()
        SetForegroundWindow (handle(Index))
        
        'EBhE؂ւ҂
        DoEvents
        wait (250)
        
        Dim i As Integer
        For i = 0 To UBound(appInfo(Index).sendKeyIndex)
            Call SendKeys(keyconfig(appInfo(Index).sendKeyIndex(i)).sendKey, True)
            wait (50)
        Next
    End If
End Sub

'zbgL[ꂽƂ̏
Public Sub SwitchKeyDown()

    Static time As Long    'OAL[
    Dim now As Long
    
    now = timeGetTime()
    
    'OL[Ă莞Ԉȓ珈s
    If (time <> 0) Then
        If (now - time < 500) Then
            time = 0
            now = 0
            Call SwitchActiveApp
        End If
    End If
    
    time = now
End Sub

'EFCg֐
Private Sub wait(wait As Integer)
    Dim time As Long
    time = timeGetTime()
    Do
        DoEvents
    Loop While (timeGetTime() - time < wait)
End Sub

