Attribute VB_Name = "TasktrayModule"
Option Explicit
'^XNgCɃACR\@ɂ[Microsoft VisualBasic Developer Center]
'http://www.microsoft.com/japan/msdn/vbasic/migration/tips/NotifyIcon/

Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long

Public udtNotifyIconData As NOTIFYICONDATA

Type NOTIFYICONDATA
    cbSize As Long
    hWnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 128
    
    dwState As Long
    dwStateMask As Long
    szInfo As String * 256
    uTimeoutOrVersion As Long
    szInfoTitle As String * 64
    dwInfoFlags As Long
End Type

Public Const NIF_ICON = &H2
Public Const NIF_MESSAGE = &H1
Public Const NIF_TIP = &H4
Public Const NIF_INFO = &H10

Public Const NIM_ADD = &H0
Public Const NIM_DELETE = &H2
Public Const NIM_MODIFY = &H1

Public Const NIIF_NONE = &H0
Public Const NIIF_INFO = &H1
Public Const NIIF_WARNING = &H2
Public Const NIIF_ERROR = &H3

Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205


'^XN XgAlt+Tab VB AvP[V \@B[Microsoft T|[gIC]
'http://support.microsoft.com/kb/114776/ja
Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long

Private Const SW_HIDE = 0
Private Const GW_OWNER = 4

Public Sub StartTasktray(TargetForm As Form, TargetMenu As Menu)
    TargetForm.Visible = False
    TargetMenu.Visible = False
    
    ' ^XN}l[W̃AvP[Vꗗ
    Dim OwnerhWnd As Long
    Dim Ret As Long
    OwnerhWnd = GetWindow(TargetForm.hWnd, GW_OWNER)
    Ret = ShowWindow(OwnerhWnd, SW_HIDE)


    With udtNotifyIconData
        .cbSize = Len(udtNotifyIconData)
        .hWnd = TargetForm.hWnd
        .uID = 1
        .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
        .uCallbackMessage = WM_MOUSEMOVE
        .hIcon = TargetForm.Icon
        .szTip = App.Title & vbNullChar
    End With

    Call Shell_NotifyIcon(NIM_ADD, udtNotifyIconData)
End Sub

Public Sub ChangeTasktrayIcon(TargetForm As Form)
    With udtNotifyIconData
        .hIcon = TargetForm.Icon
    End With
    Call Shell_NotifyIcon(NIM_MODIFY, udtNotifyIconData)
End Sub

Public Sub EndTasktray(TargetForm As Form, TargetMenu As Menu)
    Call Shell_NotifyIcon(NIM_DELETE, udtNotifyIconData)
End Sub
